

# ListProperties
<a name="API_ListProperties"></a>

This API lists the properties of a component.

## Request Syntax
<a name="API_ListProperties_RequestSyntax"></a>

```
POST /workspaces/workspaceId/properties-list HTTP/1.1
Content-type: application/json

{
   "componentName": "string",
   "componentPath": "string",
   "entityId": "string",
   "maxResults": number,
   "nextToken": "string"
}
```

## URI Request Parameters
<a name="API_ListProperties_RequestParameters"></a>

The request uses the following URI parameters.

 ** [workspaceId](#API_ListProperties_RequestSyntax) **   <a name="tm-ListProperties-request-uri-workspaceId"></a>
The workspace ID.  
Length Constraints: Minimum length of 1. Maximum length of 128.  
Pattern: `[a-zA-Z_0-9][a-zA-Z_\-0-9]*[a-zA-Z0-9]+`   
Required: Yes

## Request Body
<a name="API_ListProperties_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [componentName](#API_ListProperties_RequestSyntax) **   <a name="tm-ListProperties-request-componentName"></a>
The name of the component whose properties are returned by the operation.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 256.  
Pattern: `[a-zA-Z_\-0-9]+`   
Required: No

 ** [componentPath](#API_ListProperties_RequestSyntax) **   <a name="tm-ListProperties-request-componentPath"></a>
This string specifies the path to the composite component, starting from the top-level component.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 2048.  
Pattern: `[a-zA-Z_\-0-9/]+`   
Required: No

 ** [entityId](#API_ListProperties_RequestSyntax) **   <a name="tm-ListProperties-request-entityId"></a>
The ID for the entity whose metadata (component/properties) is returned by the operation.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 128.  
Pattern: `[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}|^[a-zA-Z0-9][a-zA-Z_\-0-9.:]*[a-zA-Z0-9]+`   
Required: Yes

 ** [maxResults](#API_ListProperties_RequestSyntax) **   <a name="tm-ListProperties-request-maxResults"></a>
The maximum number of results returned at one time. The default is 25.  
Type: Integer  
Valid Range: Minimum value of 0. Maximum value of 200.  
Required: No

 ** [nextToken](#API_ListProperties_RequestSyntax) **   <a name="tm-ListProperties-request-nextToken"></a>
The string that specifies the next page of results.  
Type: String  
Length Constraints: Minimum length of 0. Maximum length of 17880.  
Pattern: `.*`   
Required: No

## Response Syntax
<a name="API_ListProperties_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "nextToken": "string",
   "propertySummaries": [ 
      { 
         "areAllPropertyValuesReturned": boolean,
         "definition": { 
            "configuration": { 
               "string" : "string" 
            },
            "dataType": { 
               "allowedValues": [ 
                  { 
                     "booleanValue": boolean,
                     "doubleValue": number,
                     "expression": "string",
                     "integerValue": number,
                     "listValue": [ 
                        "DataValue"
                     ],
                     "longValue": number,
                     "mapValue": { 
                        "string" : "DataValue"
                     },
                     "relationshipValue": { 
                        "targetComponentName": "string",
                        "targetEntityId": "string"
                     },
                     "stringValue": "string"
                  }
               ],
               "nestedType": "DataType",
               "relationship": { 
                  "relationshipType": "string",
                  "targetComponentTypeId": "string"
               },
               "type": "string",
               "unitOfMeasure": "string"
            },
            "defaultValue": { 
               "booleanValue": boolean,
               "doubleValue": number,
               "expression": "string",
               "integerValue": number,
               "listValue": [ 
                  "DataValue"
               ],
               "longValue": number,
               "mapValue": { 
                  "string" : "DataValue"
               },
               "relationshipValue": { 
                  "targetComponentName": "string",
                  "targetEntityId": "string"
               },
               "stringValue": "string"
            },
            "displayName": "string",
            "isExternalId": boolean,
            "isFinal": boolean,
            "isImported": boolean,
            "isInherited": boolean,
            "isRequiredInEntity": boolean,
            "isStoredExternally": boolean,
            "isTimeSeries": boolean
         },
         "propertyName": "string",
         "value": { 
            "booleanValue": boolean,
            "doubleValue": number,
            "expression": "string",
            "integerValue": number,
            "listValue": [ 
               "DataValue"
            ],
            "longValue": number,
            "mapValue": { 
               "string" : "DataValue"
            },
            "relationshipValue": { 
               "targetComponentName": "string",
               "targetEntityId": "string"
            },
            "stringValue": "string"
         }
      }
   ]
}
```

## Response Elements
<a name="API_ListProperties_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [nextToken](#API_ListProperties_ResponseSyntax) **   <a name="tm-ListProperties-response-nextToken"></a>
The string that specifies the next page of property results.  
Type: String  
Length Constraints: Minimum length of 0. Maximum length of 17880.  
Pattern: `.*` 

 ** [propertySummaries](#API_ListProperties_ResponseSyntax) **   <a name="tm-ListProperties-response-propertySummaries"></a>
A list of objects that contain information about the properties.  
Type: Array of [PropertySummary](API_PropertySummary.md) objects

## Errors
<a name="API_ListProperties_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
Access is denied.  
HTTP Status Code: 403

 ** InternalServerException **   
An unexpected error has occurred.  
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The resource wasn't found.  
HTTP Status Code: 404

 ** ThrottlingException **   
The rate exceeds the limit.  
HTTP Status Code: 429

 ** ValidationException **   
Failed  
HTTP Status Code: 400

## See Also
<a name="API_ListProperties_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/iottwinmaker-2021-11-29/ListProperties) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/iottwinmaker-2021-11-29/ListProperties) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/iottwinmaker-2021-11-29/ListProperties) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/iottwinmaker-2021-11-29/ListProperties) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/iottwinmaker-2021-11-29/ListProperties) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/iottwinmaker-2021-11-29/ListProperties) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/iottwinmaker-2021-11-29/ListProperties) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/iottwinmaker-2021-11-29/ListProperties) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/iottwinmaker-2021-11-29/ListProperties) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/iottwinmaker-2021-11-29/ListProperties) 